type Long = protobuf.Long;

/** Namespace game. */
declare namespace game {

    /** Properties of a RoomInfo. */
    interface IRoomInfo {

        /** RoomInfo roomId */
        roomId?: (number|null);

        /** RoomInfo playerNum */
        playerNum?: (number|null);

        /** RoomInfo maxPlayerNum */
        maxPlayerNum?: (number|null);
    }

    /** Represents a RoomInfo. */
    class RoomInfo implements IRoomInfo {

        /**
         * Constructs a new RoomInfo.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IRoomInfo);

        /** RoomInfo roomId. */
        public roomId: number;

        /** RoomInfo playerNum. */
        public playerNum: number;

        /** RoomInfo maxPlayerNum. */
        public maxPlayerNum: number;

        /**
         * Encodes the specified RoomInfo message. Does not implicitly {@link game.RoomInfo.verify|verify} messages.
         * @param message RoomInfo message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IRoomInfo, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a RoomInfo message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns RoomInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.RoomInfo;
    }

    /** Properties of a PlayerInfo. */
    interface IPlayerInfo {

        /** PlayerInfo uid */
        uid?: (number|null);

        /** PlayerInfo x */
        x?: (number|null);

        /** PlayerInfo y */
        y?: (number|null);
    }

    /** Represents a PlayerInfo. */
    class PlayerInfo implements IPlayerInfo {

        /**
         * Constructs a new PlayerInfo.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IPlayerInfo);

        /** PlayerInfo uid. */
        public uid: number;

        /** PlayerInfo x. */
        public x: number;

        /** PlayerInfo y. */
        public y: number;

        /**
         * Encodes the specified PlayerInfo message. Does not implicitly {@link game.PlayerInfo.verify|verify} messages.
         * @param message PlayerInfo message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IPlayerInfo, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a PlayerInfo message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns PlayerInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.PlayerInfo;
    }

    /** Properties of a FrameInfo. */
    interface IFrameInfo {

        /** FrameInfo uid */
        uid?: (number|null);

        /** FrameInfo actionData */
        actionData?: (number|null);
    }

    /** Represents a FrameInfo. */
    class FrameInfo implements IFrameInfo {

        /**
         * Constructs a new FrameInfo.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IFrameInfo);

        /** FrameInfo uid. */
        public uid: number;

        /** FrameInfo actionData. */
        public actionData: number;

        /**
         * Encodes the specified FrameInfo message. Does not implicitly {@link game.FrameInfo.verify|verify} messages.
         * @param message FrameInfo message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IFrameInfo, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a FrameInfo message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns FrameInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.FrameInfo;
    }

    /** Properties of a Result. */
    interface IResult {

        /** Result code */
        code?: (number|null);

        /** Result msg */
        msg?: (string|null);
    }

    /** Represents a Result. */
    class Result implements IResult {

        /**
         * Constructs a new Result.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IResult);

        /** Result code. */
        public code: number;

        /** Result msg. */
        public msg: string;

        /**
         * Encodes the specified Result message. Does not implicitly {@link game.Result.verify|verify} messages.
         * @param message Result message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IResult, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a Result message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Result
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.Result;
    }

    /** Properties of a c2sLogin. */
    interface Ic2sLogin {

        /** c2sLogin uid */
        uid?: (number|null);
    }

    /** Represents a c2sLogin. */
    class c2sLogin implements Ic2sLogin {

        /**
         * Constructs a new c2sLogin.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sLogin);

        /** c2sLogin uid. */
        public uid: number;

        /**
         * Encodes the specified c2sLogin message. Does not implicitly {@link game.c2sLogin.verify|verify} messages.
         * @param message c2sLogin message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sLogin, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sLogin message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sLogin
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sLogin;
    }

    /** Properties of a s2cLogin. */
    interface Is2cLogin {

        /** s2cLogin result */
        result?: (game.IResult|null);
    }

    /** Represents a s2cLogin. */
    class s2cLogin implements Is2cLogin {

        /**
         * Constructs a new s2cLogin.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cLogin);

        /** s2cLogin result. */
        public result?: (game.IResult|null);

        /**
         * Encodes the specified s2cLogin message. Does not implicitly {@link game.s2cLogin.verify|verify} messages.
         * @param message s2cLogin message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cLogin, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cLogin message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cLogin
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cLogin;
    }

    /** Properties of a c2sRoomList. */
    interface Ic2sRoomList {
    }

    /** Represents a c2sRoomList. */
    class c2sRoomList implements Ic2sRoomList {

        /**
         * Constructs a new c2sRoomList.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sRoomList);

        /**
         * Encodes the specified c2sRoomList message. Does not implicitly {@link game.c2sRoomList.verify|verify} messages.
         * @param message c2sRoomList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sRoomList, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sRoomList message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sRoomList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sRoomList;
    }

    /** Properties of a s2cRoomList. */
    interface Is2cRoomList {

        /** s2cRoomList result */
        result?: (game.IResult|null);

        /** s2cRoomList roomList */
        roomList?: (game.IRoomInfo[]|null);
    }

    /** Represents a s2cRoomList. */
    class s2cRoomList implements Is2cRoomList {

        /**
         * Constructs a new s2cRoomList.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cRoomList);

        /** s2cRoomList result. */
        public result?: (game.IResult|null);

        /** s2cRoomList roomList. */
        public roomList: game.IRoomInfo[];

        /**
         * Encodes the specified s2cRoomList message. Does not implicitly {@link game.s2cRoomList.verify|verify} messages.
         * @param message s2cRoomList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cRoomList, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cRoomList message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cRoomList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cRoomList;
    }

    /** Properties of a c2sCreateRoom. */
    interface Ic2sCreateRoom {
    }

    /** Represents a c2sCreateRoom. */
    class c2sCreateRoom implements Ic2sCreateRoom {

        /**
         * Constructs a new c2sCreateRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sCreateRoom);

        /**
         * Encodes the specified c2sCreateRoom message. Does not implicitly {@link game.c2sCreateRoom.verify|verify} messages.
         * @param message c2sCreateRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sCreateRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sCreateRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sCreateRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sCreateRoom;
    }

    /** Properties of a s2cCreateRoom. */
    interface Is2cCreateRoom {

        /** s2cCreateRoom result */
        result?: (game.IResult|null);

        /** s2cCreateRoom roomId */
        roomId?: (number|null);
    }

    /** Represents a s2cCreateRoom. */
    class s2cCreateRoom implements Is2cCreateRoom {

        /**
         * Constructs a new s2cCreateRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cCreateRoom);

        /** s2cCreateRoom result. */
        public result?: (game.IResult|null);

        /** s2cCreateRoom roomId. */
        public roomId: number;

        /**
         * Encodes the specified s2cCreateRoom message. Does not implicitly {@link game.s2cCreateRoom.verify|verify} messages.
         * @param message s2cCreateRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cCreateRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cCreateRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cCreateRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cCreateRoom;
    }

    /** Properties of a c2sJoinRoom. */
    interface Ic2sJoinRoom {

        /** c2sJoinRoom roomId */
        roomId?: (number|null);
    }

    /** Represents a c2sJoinRoom. */
    class c2sJoinRoom implements Ic2sJoinRoom {

        /**
         * Constructs a new c2sJoinRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sJoinRoom);

        /** c2sJoinRoom roomId. */
        public roomId: number;

        /**
         * Encodes the specified c2sJoinRoom message. Does not implicitly {@link game.c2sJoinRoom.verify|verify} messages.
         * @param message c2sJoinRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sJoinRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sJoinRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sJoinRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sJoinRoom;
    }

    /** Properties of a s2cJoinRoom. */
    interface Is2cJoinRoom {

        /** s2cJoinRoom result */
        result?: (game.IResult|null);

        /** s2cJoinRoom playerList */
        playerList?: (number[]|null);

        /** s2cJoinRoom status */
        status?: (number|null);
    }

    /** Represents a s2cJoinRoom. */
    class s2cJoinRoom implements Is2cJoinRoom {

        /**
         * Constructs a new s2cJoinRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cJoinRoom);

        /** s2cJoinRoom result. */
        public result?: (game.IResult|null);

        /** s2cJoinRoom playerList. */
        public playerList: number[];

        /** s2cJoinRoom status. */
        public status: number;

        /**
         * Encodes the specified s2cJoinRoom message. Does not implicitly {@link game.s2cJoinRoom.verify|verify} messages.
         * @param message s2cJoinRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cJoinRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cJoinRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cJoinRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cJoinRoom;
    }

    /** Properties of a c2sDismissRoom. */
    interface Ic2sDismissRoom {

        /** c2sDismissRoom roomId */
        roomId?: (number|null);
    }

    /** Represents a c2sDismissRoom. */
    class c2sDismissRoom implements Ic2sDismissRoom {

        /**
         * Constructs a new c2sDismissRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sDismissRoom);

        /** c2sDismissRoom roomId. */
        public roomId: number;

        /**
         * Encodes the specified c2sDismissRoom message. Does not implicitly {@link game.c2sDismissRoom.verify|verify} messages.
         * @param message c2sDismissRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sDismissRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sDismissRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sDismissRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sDismissRoom;
    }

    /** Properties of a s2cDismissRoom. */
    interface Is2cDismissRoom {

        /** s2cDismissRoom result */
        result?: (game.IResult|null);
    }

    /** Represents a s2cDismissRoom. */
    class s2cDismissRoom implements Is2cDismissRoom {

        /**
         * Constructs a new s2cDismissRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cDismissRoom);

        /** s2cDismissRoom result. */
        public result?: (game.IResult|null);

        /**
         * Encodes the specified s2cDismissRoom message. Does not implicitly {@link game.s2cDismissRoom.verify|verify} messages.
         * @param message s2cDismissRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cDismissRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cDismissRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cDismissRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cDismissRoom;
    }

    /** Properties of a c2sLeaveRoom. */
    interface Ic2sLeaveRoom {
    }

    /** Represents a c2sLeaveRoom. */
    class c2sLeaveRoom implements Ic2sLeaveRoom {

        /**
         * Constructs a new c2sLeaveRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sLeaveRoom);

        /**
         * Encodes the specified c2sLeaveRoom message. Does not implicitly {@link game.c2sLeaveRoom.verify|verify} messages.
         * @param message c2sLeaveRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sLeaveRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sLeaveRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sLeaveRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sLeaveRoom;
    }

    /** Properties of a s2cLeaveRoom. */
    interface Is2cLeaveRoom {

        /** s2cLeaveRoom result */
        result?: (game.IResult|null);
    }

    /** Represents a s2cLeaveRoom. */
    class s2cLeaveRoom implements Is2cLeaveRoom {

        /**
         * Constructs a new s2cLeaveRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cLeaveRoom);

        /** s2cLeaveRoom result. */
        public result?: (game.IResult|null);

        /**
         * Encodes the specified s2cLeaveRoom message. Does not implicitly {@link game.s2cLeaveRoom.verify|verify} messages.
         * @param message s2cLeaveRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cLeaveRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cLeaveRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cLeaveRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cLeaveRoom;
    }

    /** Properties of a c2sEnterGame. */
    interface Ic2sEnterGame {
    }

    /** Represents a c2sEnterGame. */
    class c2sEnterGame implements Ic2sEnterGame {

        /**
         * Constructs a new c2sEnterGame.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sEnterGame);

        /**
         * Encodes the specified c2sEnterGame message. Does not implicitly {@link game.c2sEnterGame.verify|verify} messages.
         * @param message c2sEnterGame message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sEnterGame, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sEnterGame message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sEnterGame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sEnterGame;
    }

    /** Properties of a s2cEnterGame. */
    interface Is2cEnterGame {

        /** s2cEnterGame result */
        result?: (game.IResult|null);
    }

    /** Represents a s2cEnterGame. */
    class s2cEnterGame implements Is2cEnterGame {

        /**
         * Constructs a new s2cEnterGame.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cEnterGame);

        /** s2cEnterGame result. */
        public result?: (game.IResult|null);

        /**
         * Encodes the specified s2cEnterGame message. Does not implicitly {@link game.s2cEnterGame.verify|verify} messages.
         * @param message s2cEnterGame message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cEnterGame, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cEnterGame message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cEnterGame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cEnterGame;
    }

    /** Properties of a c2sClientInited. */
    interface Ic2sClientInited {
    }

    /** Represents a c2sClientInited. */
    class c2sClientInited implements Ic2sClientInited {

        /**
         * Constructs a new c2sClientInited.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sClientInited);

        /**
         * Encodes the specified c2sClientInited message. Does not implicitly {@link game.c2sClientInited.verify|verify} messages.
         * @param message c2sClientInited message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sClientInited, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sClientInited message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sClientInited
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sClientInited;
    }

    /** Properties of a s2cClientInited. */
    interface Is2cClientInited {

        /** s2cClientInited result */
        result?: (game.IResult|null);
    }

    /** Represents a s2cClientInited. */
    class s2cClientInited implements Is2cClientInited {

        /**
         * Constructs a new s2cClientInited.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cClientInited);

        /** s2cClientInited result. */
        public result?: (game.IResult|null);

        /**
         * Encodes the specified s2cClientInited message. Does not implicitly {@link game.s2cClientInited.verify|verify} messages.
         * @param message s2cClientInited message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cClientInited, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cClientInited message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cClientInited
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cClientInited;
    }

    /** Properties of a c2sAction. */
    interface Ic2sAction {

        /** c2sAction actionId */
        actionId?: (number|null);
    }

    /** Represents a c2sAction. */
    class c2sAction implements Ic2sAction {

        /**
         * Constructs a new c2sAction.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sAction);

        /** c2sAction actionId. */
        public actionId: number;

        /**
         * Encodes the specified c2sAction message. Does not implicitly {@link game.c2sAction.verify|verify} messages.
         * @param message c2sAction message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sAction, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sAction message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sAction
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sAction;
    }

    /** Properties of a c2sAddMonster. */
    interface Ic2sAddMonster {

        /** c2sAddMonster num */
        num?: (number|null);
    }

    /** Represents a c2sAddMonster. */
    class c2sAddMonster implements Ic2sAddMonster {

        /**
         * Constructs a new c2sAddMonster.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Ic2sAddMonster);

        /** c2sAddMonster num. */
        public num: number;

        /**
         * Encodes the specified c2sAddMonster message. Does not implicitly {@link game.c2sAddMonster.verify|verify} messages.
         * @param message c2sAddMonster message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Ic2sAddMonster, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a c2sAddMonster message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns c2sAddMonster
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.c2sAddMonster;
    }

    /** Properties of a s2cAddMonster. */
    interface Is2cAddMonster {

        /** s2cAddMonster result */
        result?: (game.IResult|null);
    }

    /** Represents a s2cAddMonster. */
    class s2cAddMonster implements Is2cAddMonster {

        /**
         * Constructs a new s2cAddMonster.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.Is2cAddMonster);

        /** s2cAddMonster result. */
        public result?: (game.IResult|null);

        /**
         * Encodes the specified s2cAddMonster message. Does not implicitly {@link game.s2cAddMonster.verify|verify} messages.
         * @param message s2cAddMonster message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.Is2cAddMonster, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a s2cAddMonster message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns s2cAddMonster
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.s2cAddMonster;
    }

    /** Properties of an onDismissRoom. */
    interface IonDismissRoom {

        /** onDismissRoom roomId */
        roomId?: (number|null);
    }

    /** Represents an onDismissRoom. */
    class onDismissRoom implements IonDismissRoom {

        /**
         * Constructs a new onDismissRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IonDismissRoom);

        /** onDismissRoom roomId. */
        public roomId: number;

        /**
         * Encodes the specified onDismissRoom message. Does not implicitly {@link game.onDismissRoom.verify|verify} messages.
         * @param message onDismissRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IonDismissRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes an onDismissRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns onDismissRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.onDismissRoom;
    }

    /** Properties of an onJoinRoom. */
    interface IonJoinRoom {

        /** onJoinRoom uid */
        uid?: (number|null);
    }

    /** Represents an onJoinRoom. */
    class onJoinRoom implements IonJoinRoom {

        /**
         * Constructs a new onJoinRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IonJoinRoom);

        /** onJoinRoom uid. */
        public uid: number;

        /**
         * Encodes the specified onJoinRoom message. Does not implicitly {@link game.onJoinRoom.verify|verify} messages.
         * @param message onJoinRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IonJoinRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes an onJoinRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns onJoinRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.onJoinRoom;
    }

    /** Properties of an onLeaveRoom. */
    interface IonLeaveRoom {

        /** onLeaveRoom uid */
        uid?: (number|null);
    }

    /** Represents an onLeaveRoom. */
    class onLeaveRoom implements IonLeaveRoom {

        /**
         * Constructs a new onLeaveRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IonLeaveRoom);

        /** onLeaveRoom uid. */
        public uid: number;

        /**
         * Encodes the specified onLeaveRoom message. Does not implicitly {@link game.onLeaveRoom.verify|verify} messages.
         * @param message onLeaveRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IonLeaveRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes an onLeaveRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns onLeaveRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.onLeaveRoom;
    }

    /** Properties of an onEnterGame. */
    interface IonEnterGame {

        /** onEnterGame playerList */
        playerList?: (game.IPlayerInfo[]|null);

        /** onEnterGame seed */
        seed?: (number|null);
    }

    /** Represents an onEnterGame. */
    class onEnterGame implements IonEnterGame {

        /**
         * Constructs a new onEnterGame.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IonEnterGame);

        /** onEnterGame playerList. */
        public playerList: game.IPlayerInfo[];

        /** onEnterGame seed. */
        public seed: number;

        /**
         * Encodes the specified onEnterGame message. Does not implicitly {@link game.onEnterGame.verify|verify} messages.
         * @param message onEnterGame message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IonEnterGame, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes an onEnterGame message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns onEnterGame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.onEnterGame;
    }

    /** Properties of an onStartGame. */
    interface IonStartGame {
    }

    /** Represents an onStartGame. */
    class onStartGame implements IonStartGame {

        /**
         * Constructs a new onStartGame.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IonStartGame);

        /**
         * Encodes the specified onStartGame message. Does not implicitly {@link game.onStartGame.verify|verify} messages.
         * @param message onStartGame message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IonStartGame, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes an onStartGame message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns onStartGame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.onStartGame;
    }

    /** Properties of an onFrame. */
    interface IonFrame {

        /** onFrame frameNum */
        frameNum?: (number|null);

        /** onFrame frameInfoList */
        frameInfoList?: (game.IFrameInfo[]|null);
    }

    /** Represents an onFrame. */
    class onFrame implements IonFrame {

        /**
         * Constructs a new onFrame.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IonFrame);

        /** onFrame frameNum. */
        public frameNum: number;

        /** onFrame frameInfoList. */
        public frameInfoList: game.IFrameInfo[];

        /**
         * Encodes the specified onFrame message. Does not implicitly {@link game.onFrame.verify|verify} messages.
         * @param message onFrame message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IonFrame, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes an onFrame message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns onFrame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.onFrame;
    }

    /** Properties of an onAddMonster. */
    interface IonAddMonster {

        /** onAddMonster result */
        result?: (game.IResult|null);

        /** onAddMonster num */
        num?: (number|null);
    }

    /** Represents an onAddMonster. */
    class onAddMonster implements IonAddMonster {

        /**
         * Constructs a new onAddMonster.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IonAddMonster);

        /** onAddMonster result. */
        public result?: (game.IResult|null);

        /** onAddMonster num. */
        public num: number;

        /**
         * Encodes the specified onAddMonster message. Does not implicitly {@link game.onAddMonster.verify|verify} messages.
         * @param message onAddMonster message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IonAddMonster, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes an onAddMonster message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns onAddMonster
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.onAddMonster;
    }

    /** Properties of an onCreateRoom. */
    interface IonCreateRoom {

        /** onCreateRoom result */
        result?: (game.IResult|null);

        /** onCreateRoom roomInfo */
        roomInfo?: (game.IRoomInfo|null);
    }

    /** Represents an onCreateRoom. */
    class onCreateRoom implements IonCreateRoom {

        /**
         * Constructs a new onCreateRoom.
         * @param [properties] Properties to set
         */
        constructor(properties?: game.IonCreateRoom);

        /** onCreateRoom result. */
        public result?: (game.IResult|null);

        /** onCreateRoom roomInfo. */
        public roomInfo?: (game.IRoomInfo|null);

        /**
         * Encodes the specified onCreateRoom message. Does not implicitly {@link game.onCreateRoom.verify|verify} messages.
         * @param message onCreateRoom message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: game.IonCreateRoom, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes an onCreateRoom message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns onCreateRoom
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): game.onCreateRoom;
    }
}
